from PyQt5.QtCore import QVariant
from bs4 import BeautifulSoup
from qgis._core import QgsVectorLayer, QgsFields, QgsField, QgsFeature
from qgis.core import QgsProject
from qgis.utils import iface

# 获取当前选中的图层
selected_layers = iface.layerTreeView().selectedLayers()
layName = "ssjcon"
layersave = QgsProject.instance().mapLayersByName(layName)
if layersave:
    for layer in layersave:
        QgsProject.instance().removeMapLayer(layer.id())

layerset = QgsVectorLayer("Polygon?crs=EPSG:4326", layName, "memory")
fields = QgsFields()  # 创建字段集合
columns = [
    "FID",
    "OBJECTID_1",
    "FID_新村",
    "XZDM",
    "XZMC",
    "ZLDWDM",
    "ZLDWMC",
    "bz",
    "WZD",
    "CZDWT",
    "mj",
    "FID_c51192",
    "LX",
    "Shape_Leng",
    "Shape_Le_1"
]
provider = layerset.dataProvider()  # 获取图层的数据提供者
for col in columns:
    fields.append(QgsField(col, QVariant.String))

provider.addAttributes(fields)  # 将字段添加到数据提供者
layerset.updateFields()  # 更新图层的字段

if not selected_layers:
    print("没有选中的图层。")
else:

    for layer in selected_layers:
        for feature in layer.getFeatures():
            # 获取 'description' 字段的值
            html_content = feature['description']
            soup = BeautifulSoup(html_content, "html.parser")
            # 查找所有的 <table> 标签
            tables = soup.find_all('table')
            # 遍历每个 <table>
            new_feature = QgsFeature(fields)  # 创建新特征
            new_feature.setGeometry(feature.geometry())  # 设置几何对象
            for table in tables:
                # 查找所有 <tr> 标签
                rows = table.find_all('tr')
                # 遍历每行
                for row in rows:
                    # 获取所有 <td> 标签
                    cells = row.find_all('td')
                    # 检查是否有两个 <td>
                    if len(cells) == 2:
                        field = cells[0].get_text(strip=True)  # 获取字段名
                        value = cells[1].get_text(strip=True)  # 获取对应值
                        new_feature[field] = value
            provider.addFeatures([new_feature])  # 将特征添加到数据提供者

QgsProject.instance().addMapLayer(layerset, True)


from qgis.core import QgsProject
from qgis.utils import iface

# 获取当前选中的图层
selected_layers = iface.layerTreeView().selectedLayers()
print(selected_layers)
if not selected_layers:
    print("没有选中的图层。")
else:
    k = 1
    for layer in selected_layers:
        for feature in layer.getFeatures():
            layer.hideFeature(feature.id())



    #
    # def add_menu_actions(self, menu_name, submenu_items):
    #     """添加菜单项及其子菜单"""
    #     # 创建菜单项
    #     action = QtWidgets.QAction(QCoreApplication.translate("cyanlove", menu_name),
    #                                self.iface.mainWindow())
    #     self.menu.addAction(action)
    #     self.actions.append(action)  # 保存动作
    #
    #     if menu_name in ["数据入库", "网络优化"]:
    #         separator = QAction(self.menu)
    #         separator.setSeparator(True)  # 设置为分割线
    #         # 将分割线添加到菜单中
    #         self.menu.addAction(separator)
    #     # 创建子菜单
    #     submenu = self.create_submenu(menu_name, submenu_items)
    #     action.setMenu(submenu)
    #
    # def create_submenu(self, submenu_name, actions):
    #     """创建子菜单的通用函数"""
    #     submenu = QtWidgets.QMenu(QCoreApplication.translate("cyanlove", submenu_name), self.iface.mainWindow())
    #     for action_name, method, icon_path in actions:
    #         self.add_submenu_action(submenu, action_name, method, icon_path)
    #     return submenu
    #
    # def add_submenu_action(self, submenu, action_name, method, icon_path):
    #     """添加一个子菜单项的通用函数，带图标"""
    #     action = QtWidgets.QAction(QCoreApplication.translate("cyanlove", action_name), self.iface.mainWindow())
    #     action.triggered.connect(method)  # 连接到指定的方法
    #     action.setIcon(QtGui.QIcon(icon_path))  # 添加图标
    #     submenu.addAction(action)  # 将动作添加到子菜单